/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package adictosaltrabajo;

import java.net.URL;
import java.util.HashMap;
import java.util.logging.Level;
import java.util.logging.Logger;



import com.jme.bounding.BoundingBox;
import com.jme.image.Texture;
import com.jme.input.ChaseCamera;
import com.jme.input.InputHandler;
import com.jme.input.KeyBindingManager;
import com.jme.input.KeyInput;
import com.jme.input.thirdperson.ThirdPersonMouseLook;
import com.jme.light.DirectionalLight;
import com.jme.math.FastMath;
import com.jme.math.Vector3f;
import com.jme.renderer.Camera;
import com.jme.renderer.ColorRGBA;
import com.jme.renderer.Renderer;
import com.jme.renderer.pass.BasicPassManager;
import com.jme.renderer.pass.RenderPass;
import com.jme.renderer.pass.ShadowedRenderPass;
import com.jme.scene.Node;
import com.jme.scene.Skybox;
import com.jme.scene.Spatial;
import com.jme.scene.state.CullState;
import com.jme.scene.state.LightState;
import com.jme.scene.state.ZBufferState;
import com.jme.util.TextureManager;
import com.jme.util.Timer;

import com.jme.app.FixedLogicrateGame;


import com.jme.intersection.BoundingCollisionResults;
import com.jme.intersection.CollisionResults;
import com.jme.scene.BillboardNode;
import com.jme.scene.state.TextureState;
import com.jme.system.*;
import com.jme.util.export.xml.XMLImporter;
import com.jmex.terrain.TerrainBlock;
import com.jmex.terrain.util.MidPointHeightMap;
import com.jmex.terrain.util.ProceduralTextureGenerator;
import java.awt.Color;
import javax.swing.ImageIcon;
import jmetest.terrain.TestTerrain;

// clase para cargar los modelos que vamos desarrollando
/**
 *
 * @author rcanales
 */
public class Juego extends FixedLogicrateGame {

    private int width, height, depth, freq;
    private boolean fullscreen;
    private static final Logger logger = Logger.getLogger(Juego.class.getName());
    private static ShadowedRenderPass shadowPass = new ShadowedRenderPass();
    private BasicPassManager passManager;
    // El terreno donde andara nuestra moto.
    private Skybox skybox;
    //el jugador que moveremos.
    private Mosca player;
    protected InputHandler input;
    //Variable de tiempo que se usa para las velocidades
    protected Timer timer;
    //La camara
    private Camera cam;
    //La camara que sigue a nuestro jugador
    private ChaseCamera chaser;
    //El nodo principal del juego
    protected Node scene;
    //Altura sobre el nivel el suelo
    private float agl;
    private Objects caja;
    private CollisionResults results1,results2,results3,results4;
    private TextLabel2D label = new TextLabel2D("");
    private BillboardNode bNode;
    private Boolean choque = false;
    private TerrainBlock tb;
    private Vector3f normal = new Vector3f();
    private Secuencia recorrido= new Secuencia();
    private Objects bola1;
    private Objects bola2;
    private Objects bola3;
    private Objects bola4;

    static public void main(String[] args) {
        Juego app = new Juego();
        //Foto de la pantalla unicial
        app.setConfigShowMode(ConfigShowMode.AlwaysShow, Juego.class.getClassLoader().getResource(
                "adictosaltrabajo/images/Autentia.jpg"));
        app.setConfigShowMode(ConfigShowMode.AlwaysShow);
        app.start();

    }

    /**
     * durante la actualizacion de la pantalla miraremos si se ha pulsado el boton
     * escape.
     */

    //Funcion de refresco del juego
    protected void update(float interpolacion) {
        
        // System.out.println("Hora: " + System.currentTimeMillis() + " interpolacion: " + interpolacion);

        // actualizacion del framerate11
        timer.update();
        interpolacion = timer.getTimePerFrame();

        //actualizacion de las entradas de teclado para que el jugador se mueva
        input.update(interpolacion);
        //actualizacion de la camara
        chaser.update(interpolacion);
        //Actualización del jugador, no es necesario se fuerza al pasar interpolacion
        player.update(interpolacion);

        //Para que el skybox este centrado en la camara
        skybox.setLocalTranslation(cam.getLocation());
        skybox.updateGeometricState(0, true);


        //cuando pulsemos la tecla escape salimos. No funciona debe ser por el tipo de juego. Clase de la que deriva
        if (KeyBindingManager.getKeyBindingManager().isValidCommand("exit")) {
            finished = true;
            System.exit(0);
        }
        //La camara no baje nunca del terreno
        if (cam.getLocation().y < (tb.getHeight(cam.getLocation()) + 2)) {
            cam.getLocation().y = tb.getHeight(cam.getLocation()) + 2;
            cam.update();
        }
        //Toma la altura del tablero segun donde este situado el player y le suma la altura de la boundingBox del player (ag1)
        float characterMinHeight = tb.getHeight(player.getLocalTranslation()) + agl;

        if (!Float.isInfinite(characterMinHeight) && !Float.isNaN(characterMinHeight)) {

            player.getLocalTranslation().y = characterMinHeight;
        }
        //getSurfaceNormal, devuelve la normal del terreno en el punto donde este el jugador
        tb.getSurfaceNormal(player.getLocalTranslation(), normal);
        if (normal != null) {
            player.rotateUpTo(normal);
        }
        /**
         * como estamos cambiado la escena, necesitamos actualizar
         * los graficos
         */
        scene.updateGeometricState(interpolacion, true);


//        results1.clear();
//        player.calculateCollisions(bola1, results1);
//        results2.clear();
//        player.calculateCollisions(bola2, results2);
//        results3.clear();
//        player.calculateCollisions(bola3, results3);
//        results4.clear();
//        player.calculateCollisions(bola4, results4);
        //Es donde va el jugador, luego tendrá que actualizarse en la clase del jugador ya que recalcualara donde ir cuando
        //detecte colisiones y demas
        player.GoTo(new Vector3f(150, 0, 70));
    }
    //Igual
    protected void render(float interpolacion) {
        // limpiamos la pantalla
        display.getRenderer().clearBuffers();

        passManager.renderPasses(display.getRenderer());
    }
    //Crea demasiados hijos
    private void CrearEtiqueta() {
        label.setText("Ouch!!!!!");
        bNode = label.getBillboard(2f);
        bNode.getLocalTranslation().y += 3;
        player.attachChild(bNode);
    }
    //Intento de borrarlas 
    private void BorrarEtiqueta() {
        //     bNode.detachChildNamed("textLabel2d");
        //   player.detachChild(bNode);
    }

    protected void initGame() {


        results1 = new BoundingCollisionResults() {
            //Reescrito. Se puede mirar si ay una colision en el ejemplo de testCoolPong (las bolas)
            public void processCollisions() {

                if (getNumber() > 0) {


                        player.GoTo(bola2.getWorldTranslation());
                        
                } 
            }
        };
        results2 = new BoundingCollisionResults() {

            public void processCollisions() {

                if (getNumber() > 0) {


                        player.GoTo(bola3.getWorldTranslation());

                }
            }
        };
        results3 = new BoundingCollisionResults() {

            public void processCollisions() {

                if (getNumber() > 0) {


                        player.GoTo(bola4.getWorldTranslation());

                }
            }
        };
        results4 = new BoundingCollisionResults() {

            public void processCollisions() {

                if (getNumber() > 0) {


                        player.GoTo(bola1.getWorldTranslation());

                }
            }
        };

        display.setTitle("Juego de la mosca y las bolas");

        scene = new Node("Escena Global");


        ZBufferState buf = display.getRenderer().createZBufferState();
        buf.setEnabled(true);
        buf.setFunction(ZBufferState.TestFunction.LessThanOrEqualTo);
        scene.setRenderState(buf);

        /**
         * vamos hacer una pequeï¿½a optimizacion. No necesitamos renderizar, la cara
         * de atras de los triangulos, entonces no lo haremos, esto nos dara un empuje
         * sin mucho esfuerzo
         */
        //Sin tocar
        CullState cs = display.getRenderer().createCullState();
        cs.setCullFace(CullState.Face.Back);
        scene.setRenderState(cs);

        buildTerrain();
        //aï¿½adimos luz
        buildLighting();
        //aï¿½adimos eï¿½ campo de fuerza
        buildSkyBox();
        //Construimos la secuencia
        buildSecuence();
        //construimos al jugador
        buildPlayer();
        //construimos la camara de seguimiento
        buildChaseCamera();
        //construimos el Input del jugador
        buildInput();

        buildPassManager();
        //Sera el de crear las bolas
        //buildObjects();


//        player.GoTo(bola4.getWorldTranslation());
        // update the scene graph for rendering
        scene.updateGeometricState(0.0f, true);
        scene.updateRenderState();
        //25 frames por segundo
        setLogicTicksPerSecond(25);




    }
    //Metodo a acabar. Puntos para que vaya para una bola y otra
    private void buildSecuence(){
        recorrido.Add(new Vector3f());
    }
    private void buildPassManager() {
        passManager = new BasicPassManager();

        // Add skybox first to make sure it is in the background
        RenderPass rPass = new RenderPass();
        rPass.add(skybox);
        passManager.add(rPass);

        shadowPass.add(scene);
        shadowPass.addOccluder(player);
        shadowPass.setRenderShadows(true);
        shadowPass.setLightingMethod(ShadowedRenderPass.LightingMethod.Modulative);
        passManager.add(shadowPass);
    }

    private void buildPlayer() {

        Spatial moscaCargadaNodo = null;

        try {
            CargadorModelos c = new CargadorModelos(new URL("file:///C:\\Autentia\\JME\\ejemploMoscas\\AEXPORTACIONES\\default-jme.xml"));
            moscaCargadaNodo = c.CargaModelo();
            moscaCargadaNodo.setModelBound(new BoundingBox());
            moscaCargadaNodo.updateModelBound();
            moscaCargadaNodo.setLocalScale(1f);
        } catch (Exception e) {
            e.printStackTrace();
            logger.log(Level.INFO, "Imposible insertar modelo");
        }


        player = new Mosca("Mosca", moscaCargadaNodo);
        player.setLocalTranslation(new Vector3f(100, 0, 100));
        label.setBackground(Color.red);
        //Todo lo que se quiere mostrar en el juego debe ser hijo de algo
        player.attachChild(bNode);

        //Por ejemplo player sera hijo de escena
        scene.attachChild(player);
        scene.updateGeometricState(0, true);
        //AQUI se construye agl que es el tamaño de la y de la caja del player que utilizabamos antes. El 0,75 es porque
        //la mosca tiene el centro en la barriga
        agl = ((BoundingBox) player.getWorldBound()).yExtent + 0.75f;
        player.setRenderQueueMode(Renderer.QUEUE_OPAQUE);
    }
    //Sin tocar
    private void buildLighting() {

        DirectionalLight light = new DirectionalLight();
        light.setDiffuse(new ColorRGBA(1.0f, 1.0f, 1.0f, 1.0f));
        light.setAmbient(new ColorRGBA(0.5f, 0.5f, 0.5f, .5f));
        light.setDirection(new Vector3f(1, -1, 0));
        light.setShadowCaster(true);
        light.setEnabled(true);

        LightState lightState = display.getRenderer().createLightState();
        lightState.setEnabled(true);
        lightState.setGlobalAmbient(new ColorRGBA(.2f, .2f, .2f, 1f));
        lightState.attach(light);
        scene.setRenderState(lightState);
    }
    //Sin tocar. Es util en una clase aparte para poder generar distintos tipos de terrenos en cualquier juego
    private void buildTerrain() {


        MidPointHeightMap heightMap = new MidPointHeightMap(64, 1f);
        Vector3f terrainScale = new Vector3f(4, 0.0575f, 4);
        tb = new TerrainBlock("Terrain", heightMap.getSize(), terrainScale,
                heightMap.getHeightMap(), new Vector3f(0, 0, 0));

        tb.setModelBound(new BoundingBox());
        tb.updateModelBound();
        ProceduralTextureGenerator pt = new ProceduralTextureGenerator(
                heightMap);
        pt.addTexture(new ImageIcon(TestTerrain.class.getClassLoader().getResource("adictosaltrabajo/texturas/grassb.png")), -128, 0, 128);
        pt.addTexture(new ImageIcon(TestTerrain.class.getClassLoader().getResource("adictosaltrabajo/texturas/dirt.jpg")), 0, 128, 255);
        pt.addTexture(new ImageIcon(TestTerrain.class.getClassLoader().getResource("adictosaltrabajo/texturas/highest.jpg")), 128, 255,
                384);
        pt.createTexture(32);

        TextureState ts = display.getRenderer().createTextureState();
        Texture t1 = TextureManager.loadTexture(pt.getImageIcon().getImage(),
                Texture.MinificationFilter.Trilinear, Texture.MagnificationFilter.Bilinear, true);
        ts.setTexture(t1, 0);

        Texture t2 = TextureManager.loadTexture(
                TestTerrain.class.getClassLoader().getResource(
                "adictosaltrabajo/texturas/Detail.jpg"),
                Texture.MinificationFilter.Trilinear,
                Texture.MagnificationFilter.Bilinear);

        ts.setTexture(t2, 1);
        t2.setWrap(Texture.WrapMode.Repeat);

        t1.setApply(Texture.ApplyMode.Combine);
        t1.setCombineFuncRGB(Texture.CombinerFunctionRGB.Modulate);
        t1.setCombineSrc0RGB(Texture.CombinerSource.CurrentTexture);
        t1.setCombineOp0RGB(Texture.CombinerOperandRGB.SourceColor);
        t1.setCombineSrc1RGB(Texture.CombinerSource.PrimaryColor);
        t1.setCombineOp1RGB(Texture.CombinerOperandRGB.SourceColor);

        t2.setApply(Texture.ApplyMode.Combine);
        t2.setCombineFuncRGB(Texture.CombinerFunctionRGB.AddSigned);
        t2.setCombineSrc0RGB(Texture.CombinerSource.CurrentTexture);
        t2.setCombineOp0RGB(Texture.CombinerOperandRGB.SourceColor);
        t2.setCombineSrc1RGB(Texture.CombinerSource.Previous);
        t2.setCombineOp1RGB(Texture.CombinerOperandRGB.SourceColor);

        tb.setRenderState(ts);
        tb.setDetailTexture(1, 16);
        tb.setRenderQueueMode(Renderer.QUEUE_OPAQUE);

        scene.attachChild(tb);


    }
    // Ya estraido a clase aparte
    private void buildSkyBox() {
//        skybox = new Skybox("skybox", 100, 100, 100);
//
//        Texture north = TextureManager.loadTexture(
//                TestSkybox.class.getClassLoader().getResource(
//                "adictosaltrabajo/texturas/north.jpg"),
//                Texture.MinificationFilter.BilinearNearestMipMap,
//                Texture.MagnificationFilter.Bilinear);
//        Texture south = TextureManager.loadTexture(
//                TestSkybox.class.getClassLoader().getResource(
//                "adictosaltrabajo/texturas/south.jpg"),
//                Texture.MinificationFilter.BilinearNearestMipMap,
//                Texture.MagnificationFilter.Bilinear);
//        Texture east = TextureManager.loadTexture(
//                TestSkybox.class.getClassLoader().getResource(
//                "adictosaltrabajo/texturas/east.jpg"),
//                Texture.MinificationFilter.BilinearNearestMipMap,
//                Texture.MagnificationFilter.Bilinear);
//        Texture west = TextureManager.loadTexture(
//                TestSkybox.class.getClassLoader().getResource(
//                "adictosaltrabajo/texturas/west.jpg"),
//                Texture.MinificationFilter.BilinearNearestMipMap,
//                Texture.MagnificationFilter.Bilinear);
//        Texture up = TextureManager.loadTexture(
//                TestSkybox.class.getClassLoader().getResource(
//                "adictosaltrabajo/texturas/top.jpg"),
//                Texture.MinificationFilter.BilinearNearestMipMap,
//                Texture.MagnificationFilter.Bilinear);
//        Texture down = TextureManager.loadTexture(
//                TestSkybox.class.getClassLoader().getResource(
//                "adictosaltrabajo/texturas/bottom.jpg"),
//                Texture.MinificationFilter.BilinearNearestMipMap,
//                Texture.MagnificationFilter.Bilinear);
//
//        skybox.setTexture(Skybox.Face.North, north);
//        skybox.setTexture(Skybox.Face.West, west);
//        skybox.setTexture(Skybox.Face.South, south);
//        skybox.setTexture(Skybox.Face.East, east);
//        skybox.setTexture(Skybox.Face.Up, up);
//        skybox.setTexture(Skybox.Face.Down, down);
//        skybox.preloadTextures();
//
//        skybox.setLocalTranslation(0, 95, 0);
//
//        skybox.updateRenderState();

        skybox = new MiSkyBox();
        scene.attachChild(skybox);
    }
    //No esta en uso
    private void buildObjects() {

        //caja = new Objects("box");
        TextureState ts = display.getRenderer().createTextureState();
        ts = display.getRenderer().createTextureState();
        Texture t0 = TextureManager.loadTexture(
                Juego.class.getClassLoader().getResource(
                "adictosaltrabajo/texturas/wall.jpg"),
                Texture.MinificationFilter.Trilinear,
                Texture.MagnificationFilter.Bilinear);
        t0.setWrap(Texture.WrapMode.Repeat);
        ts.setTexture(t0);

        bola1 = new Objects("bola1");
        bola1.setRenderState(ts);
        bola2 = new Objects("bola2");
        bola2.setRenderState(ts);
        bola3 = new Objects("bola3");
        bola3.setRenderState(ts);
        bola4 = new Objects("bola4");
        bola4.setRenderState(ts);

        bola1.setLocalTranslation(50, 3, 2);
        bola2.setLocalTranslation(50, 3, 50);
        bola3.setLocalTranslation(2, 3, 50);
        bola4.setLocalTranslation(2, 3, 2);


        for ( int i=0; i <=recorrido.Tamaño() ; i++){

        }

    }
    //Sin tocar. Bueno entenderlo. Metodos interesantes
    private void buildChaseCamera() {
        HashMap<String, Object> props = new HashMap<String, Object>();
        props.put(ThirdPersonMouseLook.PROP_MAXROLLOUT, "6");
        props.put(ThirdPersonMouseLook.PROP_MINROLLOUT, "3");
        props.put(ThirdPersonMouseLook.PROP_MAXASCENT, "" + 45 * FastMath.DEG_TO_RAD);
        props.put(ChaseCamera.PROP_INITIALSPHERECOORDS, new Vector3f(5, 0, 30 * FastMath.DEG_TO_RAD));
        props.put(ChaseCamera.PROP_DAMPINGK, "4");
        props.put(ChaseCamera.PROP_SPRINGK, "9");
        chaser = new ChaseCamera(cam, player, props);
        chaser.setMaxDistance(80);
        chaser.setMinDistance(40);
    }
    //Aqui se crea el input
    private void buildInput() {
        input = new moscaInputHandler(player, settings.getRenderer());
    }

    /**
     * se llamara si cambia la resolucion
     */
    protected void reinit() {
        display.recreateWindow(width, height, depth, freq, fullscreen);
    }

    /**
     * cerrams la ventana y salimos de la aplicacion
     */
    protected void quit() {
        super.quit();
        System.exit(0);
    }

    /**
     * limpiamos las texturas
     */
    protected void cleanup() {
    }
    //inicializaciones del sistema. Roberto modificado
    protected void initSystem() {

        width = settings.getWidth();
        height = settings.getHeight();
        depth = settings.getDepth();
        freq = settings.getFrequency();
        fullscreen = settings.isFullscreen();

        try {
            display = DisplaySystem.getDisplaySystem(settings.getRenderer());
            display.setMinStencilBits(8);
            display.createWindow(width, height, depth, freq, fullscreen);

            cam = display.getRenderer().createCamera(width, height);
        } catch (JmeException e) {
            logger.log(Level.SEVERE, "Could not create displaySystem", e);
            System.exit(1);
        }

        display.getRenderer().setBackgroundColor(ColorRGBA.black.clone());

        cam.setFrustumPerspective(45.0f, (float) width / (float) height, 1,
                200);
        cam.setLocation(new Vector3f(-100, 100, -100));
        //cam.lookAt(Vector3f.ZERO,new Vector3f(0,1,0)); //que mire al punto 0 en vertical

        cam.update();

        timer = Timer.getTimer();

        display.getRenderer().setCamera(cam);

        KeyBindingManager.getKeyBindingManager().set("exit",
                KeyInput.KEY_ESCAPE);

    }

    /**
     * @see AbstractGame#getNewSettings()
     */
    //Metodo que exige el tipo de juego del que hereda
    protected GameSettings getNewSettings() {
        return new DefaultGameSettings();
    }

    /**
     * A PropertiesGameSettings which defaults Fullscreen to TRUE.
     */
    static class DefaultGameSettings extends PropertiesGameSettings {

        static {
            // This is how you programmatically override the DEFAULT_*
            // settings of GameSettings.
            // You can also make declarative overrides by using
            // "game-defaults.properties" in a CLASSPATH root directory (or
            // use the 2-param PropertiesGameSettings constructor for any name).
            // (This is all very different from the user-specific
            // "properties.cfg"... or whatever file is specified below...,
            // which is read from the current directory and is session-specific).
            defaultFullscreen = Boolean.TRUE;
        }

        /**
         * Populates the GameSettings from the (session-specific) .properties
         * file.
         */
        DefaultGameSettings() {
            super("properties.cfg");
            load();
        }
    }
}

