/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package adictosaltrabajo;

/**
 *
 * @author rcanales
 */
import com.jme.input.InputHandler;
import com.jme.input.KeyBindingManager;
import com.jme.input.KeyInput;

public class moscaInputHandler extends InputHandler {

    private Mosca mimosca;

    public moscaInputHandler(Mosca pmosca, String api) {
        this.mimosca = pmosca;
        setKeyBindings(api);
        setActions(pmosca);

    }

    public void update(float time) {

       //  System.out.println("****************************************** estamos en update");

        if (!isEnabled()) {
            return;
        }

        super.update(time);

        mimosca.update(time);
    }

    /**
     * setKeyBindings establece las teclas que permitiran manejar
     * la Mosca. En este caso las flechas
     */
    private void setKeyBindings(String api) {

       
        KeyBindingManager keyboard = KeyBindingManager.getKeyBindingManager();

        keyboard.removeAll();

        keyboard.add("ARRIBA", KeyInput.KEY_UP);
        keyboard.add("ABAJO", KeyInput.KEY_DOWN);
        keyboard.add("DERECHA", KeyInput.KEY_RIGHT);
        keyboard.add("IZQUIERDA", KeyInput.KEY_LEFT);

         
    }

    /**
     * setActions define los triggers para las teclas,
     * para que hagan la accion que queremos cuando pulsamos.
     */
    private void setActions(Mosca node) {

      
        MoverMoscaKeyInputAction forward = new MoverMoscaKeyInputAction(node, MoverMoscaKeyInputAction.ARRIBA);

        addAction(forward, "ARRIBA", true);
        MoverMoscaKeyInputAction backward = new MoverMoscaKeyInputAction(node, MoverMoscaKeyInputAction.ABAJO);
        addAction(backward, "ABAJO", true);
        MoverMoscaKeyInputAction rotateLeft = new MoverMoscaKeyInputAction(node, MoverMoscaKeyInputAction.IZQUIERDA);
        addAction(rotateLeft, "IZQUIERDA", true);
        MoverMoscaKeyInputAction rotateRight = new MoverMoscaKeyInputAction(node, MoverMoscaKeyInputAction.DERECHA);
        addAction(rotateRight, "DERECHA", true);

        
    }
}
